You can not select more than 25 topics Topics must start with a letter or number, can include dashes ('-') and can be up to 35 characters long.

155 lines
6.3 KiB

преди 9 години
преди 9 години
преди 9 години
  1. #!/usr/bin/env zsh
  2. # -------------------------------------------------------------------------------------------------
  3. # Copyright (c) 2010-2015 zsh-syntax-highlighting contributors
  4. # All rights reserved.
  5. #
  6. # Redistribution and use in source and binary forms, with or without modification, are permitted
  7. # provided that the following conditions are met:
  8. #
  9. # * Redistributions of source code must retain the above copyright notice, this list of conditions
  10. # and the following disclaimer.
  11. # * Redistributions in binary form must reproduce the above copyright notice, this list of
  12. # conditions and the following disclaimer in the documentation and/or other materials provided
  13. # with the distribution.
  14. # * Neither the name of the zsh-syntax-highlighting contributors nor the names of its contributors
  15. # may be used to endorse or promote products derived from this software without specific prior
  16. # written permission.
  17. #
  18. # THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" AND ANY EXPRESS OR
  19. # IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND
  20. # FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR
  21. # CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
  22. # DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
  23. # DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
  24. # IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT
  25. # OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
  26. # -------------------------------------------------------------------------------------------------
  27. # -*- mode: zsh; sh-indentation: 2; indent-tabs-mode: nil; sh-basic-offset: 2; -*-
  28. # vim: ft=zsh sw=2 ts=2 et
  29. # -------------------------------------------------------------------------------------------------
  30. # Check an highlighter was given as argument.
  31. [[ -n "$1" ]] || {
  32. echo >&2 "Bail out! You must provide the name of a valid highlighter as argument."
  33. exit 2
  34. }
  35. # Check the highlighter is valid.
  36. [[ -f ${0:h:h}/highlighters/$1/$1-highlighter.zsh ]] || {
  37. echo >&2 "Bail out! Could not find highlighter ${(qq)1}."
  38. exit 2
  39. }
  40. # Check the highlighter has test data.
  41. [[ -d ${0:h:h}/highlighters/$1/test-data ]] || {
  42. echo >&2 "Bail out! Highlighter ${(qq)1} has no test data."
  43. exit 2
  44. }
  45. # Load the main script.
  46. . ${0:h:h}/zsh-syntax-highlighting.zsh
  47. # Activate the highlighter.
  48. ZSH_HIGHLIGHT_HIGHLIGHTERS=($1)
  49. # Runs a highlighting test
  50. # $1: data file
  51. run_test_internal() {
  52. local -a highlight_zone
  53. local unused_highlight='bg=red,underline' # a style unused by anything else, for tests to use
  54. local tests_tempdir="$1"; shift
  55. local srcdir="$PWD"
  56. builtin cd -q -- "$tests_tempdir" || { echo >&2 "Bail out! cd failed: $?"; return 1 }
  57. echo "# ${1:t:r}"
  58. # Load the data and prepare checking it.
  59. PREBUFFER= BUFFER= ;
  60. . "$srcdir"/"$1"
  61. # Check the data declares $PREBUFFER or $BUFFER.
  62. [[ -z $PREBUFFER && -z $BUFFER ]] && { echo >&2 "Bail out! Either 'PREBUFFER' or 'BUFFER' must be declared and non-blank"; return 1; }
  63. # Check the data declares $expected_region_highlight.
  64. (( ${#expected_region_highlight} == 0 )) && { echo >&2 "Bail out! 'expected_region_highlight' is not declared or empty."; return 1; }
  65. # Process the data.
  66. region_highlight=()
  67. _zsh_highlight
  68. # Overlapping regions can be declared in region_highlight, so we first build an array of the
  69. # observed highlighting.
  70. local -A observed_result
  71. for ((i=1; i<=${#region_highlight}; i++)); do
  72. highlight_zone=${(z)region_highlight[$i]}
  73. integer start=$highlight_zone[1] end=$highlight_zone[2]
  74. if (( start < end )) # region_highlight ranges are half-open
  75. then
  76. (( --end )) # convert to closed range, like expected_region_highlight
  77. (( ++start, ++end )) # region_highlight is 0-indexed; expected_region_highlight is 1-indexed
  78. for j in {$start..$end}; do
  79. observed_result[$j]=$highlight_zone[3]
  80. done
  81. else
  82. # noop range; ignore.
  83. fi
  84. done
  85. # Then we compare the observed result with the expected one.
  86. echo "1..${#expected_region_highlight}"
  87. for ((i=1; i<=${#expected_region_highlight}; i++)); do
  88. local todo=
  89. highlight_zone=${(z)expected_region_highlight[$i]}
  90. [[ -n "$highlight_zone[4]" ]] && todo=" # TODO $highlight_zone[4]"
  91. for j in {$highlight_zone[1]..$highlight_zone[2]}; do
  92. if [[ "$observed_result[$j]" != "${(Q)highlight_zone[3]}" ]]; then
  93. echo "not ok $i ${(qqq)BUFFER[$highlight_zone[1],$highlight_zone[2]]} [$highlight_zone[1],$highlight_zone[2]]: expected ${(Q)highlight_zone[3]}, observed ${(qqq)observed_result[$j]}.$todo"
  94. continue 2
  95. fi
  96. done
  97. echo "ok $i$todo"
  98. done
  99. }
  100. # Run a single test file. The exit status is 1 if the test harness had
  101. # an error and 0 otherwise. The exit status does not depend on whether
  102. # test points succeeded or failed.
  103. run_test() {
  104. # Do not combine the declaration and initialization: «local x="$(false)"» does not set $?.
  105. local __tests_tempdir
  106. __tests_tempdir="$(mktemp -d)" && [[ -d $__tests_tempdir ]] || {
  107. echo >&2 "Bail out! mktemp failed"; return 1
  108. }
  109. typeset -r __tests_tempdir # don't allow tests to override the variable that we will 'rm -rf' later on
  110. {
  111. # Use a subshell to isolate tests from each other.
  112. # (So tests can alter global shell state using 'cd', 'hash', etc)
  113. (run_test_internal "$__tests_tempdir" "$@")
  114. } always {
  115. rm -rf -- "$__tests_tempdir"
  116. }
  117. }
  118. # Set up results_filter
  119. local results_filter
  120. if [[ $QUIET == y ]]; then
  121. if type -w perl >/dev/null; then
  122. results_filter=${0:A:h}/tap-filter
  123. else
  124. echo >&2 "Bail out! quiet mode not supported: perl not found"; exit 2
  125. fi
  126. else
  127. results_filter=cat
  128. fi
  129. [[ -n $results_filter ]] || { echo >&2 "Bail out! BUG setting \$results_filter"; exit 2 }
  130. # Process each test data file in test data directory.
  131. integer something_failed=0
  132. for data_file in ${0:h:h}/highlighters/$1/test-data/*.zsh; do
  133. run_test "$data_file" | tee >($results_filter | ${0:A:h}/tap-colorizer.zsh) | grep -v '^not ok.*# TODO' | grep -Eq '^not ok|^ok.*# TODO' && (( something_failed=1 ))
  134. (( $pipestatus[1] )) && exit 2
  135. done
  136. exit $something_failed